#include "ElementObjectData.h"

namespace AMDiS {

  void ElementObjects::createRankData() 
  {
    for (std::map<DegreeOfFreedom, std::vector<ElementObjectData> >::iterator it = vertexElements.begin();
	 it != vertexElements.end(); ++it) {
      for (std::vector<ElementObjectData>::iterator it2 = it->second.begin(); it2 != it->second.end(); ++it2) {
	int elOwner = elementInRank[it2->elIndex];
	
	if (it2->elIndex > vertexInRank[it->first][elOwner].elIndex)
	  vertexInRank[it->first][elOwner] = *it2;
      }
    }
    
    
    for (std::map<DofEdge, std::vector<ElementObjectData> >::iterator it = edgeElements.begin();
	 it != edgeElements.end(); ++it) {
      for (std::vector<ElementObjectData>::iterator it2 = it->second.begin(); it2 != it->second.end(); ++it2) {
	int elOwner = elementInRank[it2->elIndex];
	
	if (it2->elIndex > edgeInRank[it->first][elOwner].elIndex)
	  edgeInRank[it->first][elOwner] = *it2;
      }
    }
    
    for (std::map<DofFace, std::vector<ElementObjectData> >::iterator it = faceElements.begin();
	 it != faceElements.end(); ++it) {
      for (std::vector<ElementObjectData>::iterator it2 = it->second.begin(); it2 != it->second.end(); ++it2) {
	int elOwner = elementInRank[it2->elIndex];
	
	if (it2->elIndex > faceInRank[it->first][elOwner].elIndex)
	  faceInRank[it->first][elOwner] = *it2;
      }
    }
  }

}
